//Create a class for relative humidity measurement
package RelativeHumidityMeasurement
import Timer.SimulatedTimer

//JPF's Verify API
import gov.nasa.jpf.vm.Verify

public class RelativeHumidityMeasurements {
	private int deviceNumbers
	private List humidityMeasurements
	def sendEvent

	//For one device(We cannot have obj.id)-> We should have obj[0].id
	private String id = "humidityMeasurementID0"
	private String label = "humidityMeasurement0"
	private String displayName = "humidityMeasurement0"
	private int humidity = 50
	private int currentHumidity = 50

		
	RelativeHumidityMeasurements(Closure sendEvent, int deviceNumbers) {
		this.sendEvent = sendEvent		
		this.deviceNumbers = deviceNumbers
		this.humidityMeasurements = []

		//def init = Verify.getIntFromList(30, 50, 70)
		//this.humidity = init

		humidityMeasurements.add(new RelativeHumidityMeasurement(id, label, displayName, this.humidity))
	}

	//By Model Checker
	def setValue(LinkedHashMap eventDataMap) {
		if (eventDataMap["value"] != humidityMeasurements[0].humidity) {
			humidityMeasurements[0].setValue(eventDataMap["value"])
			this.humidity = humidityMeasurements[0].humidity
			this.currentHumidity = humidityMeasurements[0].currentHumidity		
			sendEvent(eventDataMap)
		}
	}

	//Methods for closures
	def count(Closure Input) {
		humidityMeasurements.count(Input)
	}
	def size() {
		humidityMeasurements.size()
	}
	def each(Closure Input) {
		humidityMeasurements.each(Input)
	}
	def find(Closure Input) {
		humidityMeasurements.find(Input)
	}
	def collect(Closure Input) {
		humidityMeasurements.collect(Input)
	}


	def currentValue(String deviceFeature) {
		humidityMeasurements[0].currentValue(deviceFeature)//It is called if we have only one device
	}

	def getAt(int ix) {
		humidityMeasurements[ix]
	}
}
