//Create a class for switch device
package Switch
import Timer.SimulatedTimer

public class Switch {
	private String id
	private String label
	private String displayName
	private String switchState
	private String currentSwitch
	private int currentLevel
	private String switchLatestValue
	def sendEvent	
	def timers
	

	Switch(Closure sendEvent, String id, String label, String displayName, String switchState, String currentSwitch, int currentLevel, String switchLatestValue) {
		this.sendEvent = sendEvent
		this.timers = new SimulatedTimer()
		this.currentSwitch = currentSwitch
		this.currentLevel = currentLevel
		this.id = id
		this.label = label
		this.displayName = displayName
		this.switchState = switchState
		this.switchLatestValue = switchLatestValue
	}

	//By Apps
	def setLevel(int level) {
		if (this.currentLevel != level) {
			println("the switch with id:$id is setted to level $level!")
			this.currentLevel = level
			sendEvent([name: "level", value: "40", deviceId: this.id, descriptionText: "",
			    displayed: true, linkText: "", isStateChange: false, unit: "", data: '{"info": "info"}'])
		}
	}

	def on() {
		if (this.switchState != "on") {
			println("the switch with id:$id is on!")
			this.switchLatestValue = this.switchState
			this.switchState = "on"
			this.currentSwitch = "on"
			sendEvent([name: "switch", value: "on", deviceId: this.id, descriptionText: "",
			    displayed: true, linkText: "", isStateChange: false, unit: "", data: '{"info": "info"}'])
		}
	}

	def on(LinkedHashMap metaData) {
		if (this.switchState != "on") {
			def task = timers.runAfter(metaData["delay"]) {
				println("the switch with id:$id is on!")
				this.switchLatestValue = this.switchState
				this.switchState = "on"
				this.currentSwitch = "on"
				sendEvent([name: "switch", value: "on", deviceId: this.id, descriptionText: "",
				    displayed: true, linkText: "", isStateChange: false, unit: "", data: '{"info": "info"}'])
			}
		}
	}

	def off() {
		if (this.switchState != "off") {
			println("the switch with id:$id is off!")
			this.switchLatestValue = this.switchState
			this.switchState = "off"
			this.currentSwitch = "off"
			sendEvent([name: "switch", value: "off", deviceId: this.id, descriptionText: "",
			    displayed: true, linkText: "", isStateChange: false, unit: "", data: '{"info": "info"}'])
		}
	}

	def off(LinkedHashMap metaData) {
		if (this.switchState != "off") {
			def task = timers.runAfter(metaData["delay"]) {
				println("the switch with id:$id is off!")
				this.switchLatestValue = this.switchState
				this.switchState = "off"
				this.currentSwitch = "off"
				sendEvent([name: "switch", value: "off", deviceId: this.id, descriptionText: "",
				    displayed: true, linkText: "", isStateChange: false, unit: "", data: '{"info": "info"}'])
			}
		}
	}

	//By Model Checker
	def setValue(String value) {
		println("the switch with id:$id is $value!")
		this.switchLatestValue = this.switchState
		this.switchState = value
		this.currentSwitch = value
	}
	
	def currentValue(String deviceFeature) {
		if (deviceFeature == "switch") {
			return switchState
		}
	}

	def latestValue(String deviceFeature) {
		if (deviceFeature == "switch") {
			return switchLatestValue
		}
	}
}
